Name "Configurazione backup"
# MUI defines
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_FINISHPAGE_NOAUTOCLOSE
# Included files
!include Sections.nsh
!include MUI.nsh
!include InstallOptions.nsh
!include "LogicLib.nsh"
!include 'TextFunc.nsh'
!include 'FileFunc.nsh'

Function .onInit
    InitPluginsDir
    File /oname=$PLUGINSDIR\setup1.ini "setup1.ini"
    File /oname=$PLUGINSDIR\setup2.ini "setup2.ini"
    File /oname=$PLUGINSDIR\setup3.ini "setup3.ini"
FunctionEnd

# Installer pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
Page custom InstallOptions
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

# Installer languages
!insertmacro MUI_LANGUAGE Italian

Function InstallOptions
  !insertmacro INSTALLOPTIONS_DISPLAY "setup1.ini"
  !insertmacro INSTALLOPTIONS_DISPLAY "setup2.ini"
  !insertmacro INSTALLOPTIONS_DISPLAY "setup3.ini"
FunctionEnd

# Installer attributes
OutFile configurazione_backup.exe
InstallDir c:\script
CRCCheck on
XPStyle on
ShowInstDetails show
#BGGradient 000000 000000 000000

Section Backup SEC0000
    SetOutPath $INSTDIR  
    SetOverwrite on
    File start.bat
    File setup_BACKUP.bat
    File setup_TAPES.bat
    
    # DBNAME
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 8" "State"    
    Push "--DBNAME--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_TAPES.bat
    Call AdvReplaceInFile
    Push "--DBNAME--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    # MYSQLDIR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 9" "State"    
    Push "--MYSQLDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    Push "--MYSQLDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
    # USER
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 1" "State"    
    Push "--USER--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    # PWD
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 3" "State"    
    Push "--PWD--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    
    # BACKUPDIR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup3.ini" "Field 1" "State"    
    Push "--BACKUPDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    Push "--BACKUPDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_BACKUP.bat
    Call AdvReplaceInFile

    # BACKUPFILE
    !insertmacro INSTALLOPTIONS_READ $R0 "setup2.ini" "Field 7" "State"    
    Push "--BACKUPFILE--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    !insertmacro INSTALLOPTIONS_READ $R0 "setup2.ini" "Field 7" "State"    
    Push "--BACKUPFILE--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_TAPES.bat
    Call AdvReplaceInFile
    
    # NTBACKUPDIR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup2.ini" "Field 9" "State"    
    Push "--NTBACKUPDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_TAPES.bat
    Call AdvReplaceInFile
    Push "--NTBACKUPDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    
    # TAPE
    !insertmacro INSTALLOPTIONS_READ $R0 "setup2.ini" "Field 4" "State"    
    Push "--TAPE--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_TAPES.bat
    Call AdvReplaceInFile
    Push "--TAPE--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    
    # TAPELIBRARY
    !insertmacro INSTALLOPTIONS_READ $R0 "setup2.ini" "Field 5" "State"    
    Push "--TAPELIBRARY--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_TAPES.bat
    Call AdvReplaceInFile
    Push "--TAPELIBRARY--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\start.bat
    Call AdvReplaceInFile
    
    # SCRIPTDIR
    Push "--SCRIPTDIR--"
    Push $INSTDIR
    Push all
    Push all
    Push $INSTDIR\setup_BACKUP.bat
    Call AdvReplaceInFile
    
    # RUSER
    !insertmacro INSTALLOPTIONS_READ $R0 "setup3.ini" "Field 6" "State"    
    Push "--RUSER--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_BACKUP.bat
    Call AdvReplaceInFile
    
    # RPWD
    !insertmacro INSTALLOPTIONS_READ $R0 "setup3.ini" "Field 8" "State"    
    Push "--RPWD--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_BACKUP.bat
    Call AdvReplaceInFile
 
    # HOUR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup3.ini" "Field 12" "State"    
    Push "--HOUR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\setup_BACKUP.bat
    Call AdvReplaceInFile

    #nsExec::Exec '"$INSTDIR\setup_BACKUP.bat"'
    ExecWait '"$INSTDIR\setup_BACKUP.bat"'

    Delete "$INSTDIR\setup_BACKUP.bat"
SectionEnd

Section Restore SEC0001
    SetOutPath $INSTDIR
    SetOverwrite on
    File restore.bat
    # MYSQLDIR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 9" "State"    
    Push "--MYSQLDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
    # DBNAME
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 8" "State"    
    Push "--DBNAME--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
    # USER
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 1" "State"    
    Push "--USER--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
    # PWD
    !insertmacro INSTALLOPTIONS_READ $R0 "setup1.ini" "Field 3" "State"    
    Push "--PWD--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
    # BACKUPDIR
    !insertmacro INSTALLOPTIONS_READ $R0 "setup3.ini" "Field 1" "State"    
    Push "--BACKUPDIR--"
    Push $R0
    Push all
    Push all
    Push $INSTDIR\restore.bat
    Call AdvReplaceInFile
   
SectionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SEC0000} $(SEC0000_DESC)
    !insertmacro MUI_DESCRIPTION_TEXT ${SEC0001} $(SEC0001_DESC)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

#Section "Setup1"

#SectionEnd

Function AdvReplaceInFile
Exch $0 ;file to replace in
Exch
Exch $1 ;number to replace after
Exch
Exch 2
Exch $2 ;replace and onwards
Exch 2
Exch 3
Exch $3 ;replace with
Exch 3
Exch 4
Exch $4 ;to replace
Exch 4
Push $5 ;minus count
Push $6 ;universal
Push $7 ;end string
Push $8 ;left string
Push $9 ;right string
Push $R0 ;file1
Push $R1 ;file2
Push $R2 ;read
Push $R3 ;universal
Push $R4 ;count (onwards)
Push $R5 ;count (after)
Push $R6 ;temp file name
 
  GetTempFileName $R6
  FileOpen $R1 $0 r ;file to search in
  FileOpen $R0 $R6 w ;temp file
   StrLen $R3 $4
   StrCpy $R4 -1
   StrCpy $R5 -1
 
loop_read:
 ClearErrors
 FileRead $R1 $R2 ;read line
 IfErrors exit
 
   StrCpy $5 0
   StrCpy $7 $R2
 
loop_filter:
   IntOp $5 $5 - 1
   StrCpy $6 $7 $R3 $5 ;search
   StrCmp $6 "" file_write2
   StrCmp $6 $4 0 loop_filter
 
StrCpy $8 $7 $5 ;left part
IntOp $6 $5 + $R3
IntCmp $6 0 is0 not0
is0:
StrCpy $9 ""
Goto done
not0:
StrCpy $9 $7 "" $6 ;right part
done:
StrCpy $7 $8$3$9 ;re-join
 
IntOp $R4 $R4 + 1
StrCmp $2 all file_write1
StrCmp $R4 $2 0 file_write2
IntOp $R4 $R4 - 1
 
IntOp $R5 $R5 + 1
StrCmp $1 all file_write1
StrCmp $R5 $1 0 file_write1
IntOp $R5 $R5 - 1
Goto file_write2
 
file_write1:
 FileWrite $R0 $7 ;write modified line
Goto loop_read
 
file_write2:
 FileWrite $R0 $R2 ;write unmodified line
Goto loop_read
 
exit:
  FileClose $R0
  FileClose $R1
 
   SetDetailsPrint none
  Delete $0
  Rename $R6 $0
  Delete $R6
   SetDetailsPrint both
 
Pop $R6
Pop $R5
Pop $R4
Pop $R3
Pop $R2
Pop $R1
Pop $R0
Pop $9
Pop $8
Pop $7
Pop $6
Pop $5
Pop $0
Pop $1
Pop $2
Pop $3
Pop $4
FunctionEnd

LangString SEC0000_DESC ${LANG_ITALIAN} "Script di configurazione per il backup"
LangString SEC0001_DESC ${LANG_ITALIAN} "Script di configurazione per il restore"
