@echo off
echo Backup...

SET TAPE=--TAPE--
SET TAPELIBRARY=--TAPELIBRARY--
SET MYSQLDIR=--MYSQLDIR--
SET DBNAME=--DBNAME--
SET PWD=--PWD--
SET USER=--USER--
SET BACKUPDIR=--BACKUPDIR--

IF NOT EXIST %BACKUPDIR% mkdir %BACKUPDIR%
IF NOT EXIST %BACKUPDIR% GOTO error

SET BACKUPFILENAME=dump_completo_
SET NTBACKUPDIR=--NTBACKUPDIR--
SET BACKUPFILE=--BACKUPFILE--

SET DAY=%1

@REM Date Configuration
for /f "tokens=1-4 delims=/ " %%a in ('date/t') do (
set dd=%%a
set mm=%%b
set yy=%%c
)
@REM Time Configuration
for /f "tokens=1-2 delims=." %%a in ('time/t') do ( 
set h=%%a
set m=%%b
)

echo Dump %DBNAME% DB ...

SET DUMPFILE=%BACKUPDIR%\%BACKUPFILENAME%%DBNAME%.sql
echo Set dump name %DUMPFILE%

echo Execute command: 
call %MYSQLDIR%\mysqldump -v --hex-blob --triggers --add-drop-database --single-transaction -c -f -u %USER% --password=%PWD% %DBNAME% > %DUMPFILE%

IF NOT EXIST %DUMPFILE% GOTO error1

echo ... Dump completed

echo Writing tape ...
echo %TAPELIBRARY% - REFRESH
rsm refresh /LF"%TAPELIBRARY%"
IF NOT %errorlevel%==0 goto:error2

echo Wait a bit...
::sleep 30

start /wait ntbackup.exe backup "@%NTBACKUPDIR%\%BACKUPFILE%" /n "%DAY%" /d "Backup giornaliero DB" /v:no /r:no /rs:no /hc:on /m normal /j "BACKUP giornaliero %DBNAME%" /l:f /T "%DAY%"
echo %errorlevel%

IF NOT %errorlevel%==0 goto:error2

rsm eject /LF"%TAPELIBRARY%" /ASTART

IF NOT %errorlevel%==0 goto:error2

echo Backup finished.

goto:eof

:error
echo Backup Error...
goto:eof
:error1
echo Mysqldump Error...
goto:eof
:error2
echo Ntbackup Error...
goto:eof
